;#########################################################################
;Assembler directives

.486
.model flat,stdcall
option casemap:none

;#########################################################################
;Include file

include CodeComplete.inc

.code

;#########################################################################
;Common AddIn Procedures

DllEntry proc hInst:HINSTANCE,reason:DWORD,reserved1:DWORD

	mov		eax,hInst
	mov		hInstance,eax
	mov		eax,TRUE
	ret

DllEntry Endp

InstallAddin proc uses ebx hWin:DWORD
	LOCAL	apifile[MAX_PATH]:BYTE
		LOCAL	buffer[1536]:BYTE
		local Rootpath[MAX_PATH]:BYTE
	mov		ebx,hWin
	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov		lpHandles,eax
	;Get handles of codecomplete listbox
	mov		edx,[eax].ADDINHANDLES.hCC
	mov		hCC,edx
	
	;Get handles of codecomplete tooltip
	mov		edx,[eax].ADDINHANDLES.hTT
	mov		hTT,edx
	;Get handles of properties
	mov		edx,[eax].ADDINHANDLES.hProperty
	mov		hProperty,edx
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov		lpProc,eax
	;Get pointer to data struct

	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov		lpData,eax
	
	pushad
	mov		ebx,lpData
	invoke lstrcpy,addr pApiFilePath,addr [ebx].ADDINDATA.szAppPath
	invoke lstrcat,addr pApiFilePath,addr szBSApiBS
	invoke lstrcat,addr pApiFilePath,addr szApiFileInc
	invoke lstrcpy,addr Rootpath,addr [ebx].ADDINDATA.szAppPath
	invoke PathStripToRoot,addr Rootpath

	invoke  GetPrivateProfileString,addr szIniEnvironment,addr szOne,NULL,addr buffer,sizeof buffer,addr [ebx].ADDINDATA.szAssemblerIni
	lea		esi,buffer
	.while byte ptr [esi]
		   .if byte ptr [esi]=='.'
			   add  esi,3
			   jmp  @F
		   .endif
		   inc	  esi
	.endw
 @@:
	invoke lstrcat,addr Rootpath,esi
	invoke lstrcat,addr Rootpath,addr szInc
	invoke SearchIncludes_Includelibs,addr pApiFilePath,addr Rootpath
	invoke ReadIncludes_Includelibs,addr pApiFilePath,addr FileDataInc
;-----------------------------------------------------------------------------		
	mov		ebx,lpData
	invoke lstrcpy,addr pApiFilePath,addr [ebx].ADDINDATA.szAppPath
	invoke lstrcat,addr pApiFilePath,addr szBSApiBS
	invoke lstrcat,addr pApiFilePath,addr szApiFileLib
	invoke lstrcpy,addr Rootpath,addr [ebx].ADDINDATA.szAppPath
	invoke PathStripToRoot,addr Rootpath

	invoke  GetPrivateProfileString,addr szIniEnvironment,addr szTwo,NULL,addr buffer,sizeof buffer,addr [ebx].ADDINDATA.szAssemblerIni
	lea		esi,buffer
	.while byte ptr [esi]
		   .if byte ptr [esi]=='.'
			   add  esi,3
			   jmp  @F
		   .endif
		   inc	  esi
	.endw
 @@:
	invoke lstrcat,addr Rootpath,esi
	invoke lstrcat,addr Rootpath,addr szLib
	invoke SearchIncludes_Includelibs,addr pApiFilePath,addr Rootpath
	invoke ReadIncludes_Includelibs,addr pApiFilePath,addr FileDataLib
	popad
	mov		hook.hook1,HOOK_RASELCHANGE
	xor		eax,eax
	mov		hook.hook2,eax
	mov		hook.hook3,eax
	mov		hook.hook4,eax
	mov		eax,offset hook
	ret 

InstallAddin Endp

IsLineInclude proc uses esi edi pIncLib:DWORD,npos:DWORD

	mov		esi,offset linebuff
	mov	edi,pIncLib
	dec		esi
	mov		ecx,npos
	inc		ecx
  @@:
	dec		ecx
	je		Ex
	inc		esi
	mov		al,[esi]
	cmp		al,VK_SPACE
	je		@b
	cmp		al,VK_TAB
	je		@b
	dec		esi
	dec		edi
	inc		ecx
  @@:
	dec		ecx
	je		Ex
	inc		esi
	inc		edi
	mov		al,[edi]
	mov		ah,[esi]
;	;Not case sensitive
;	.if al>='a' && al<='z'
;		and		al,5Fh
;	.endif
;	.if ah>='a' && ah<='z'
;		and		ah,5Fh
;	.endif
	sub		ah,al
	je		@b
	.if !al && (ah==VK_SPACE || ah==VK_TAB)
		.while byte ptr [esi]==VK_SPACE || byte ptr [esi]==VK_TAB
			inc		esi
		.endw
		mov		eax,esi
	.else
		jmp		Ex
	.endif
	ret
  Ex:
	;Not found
	xor		eax,eax
	ret

IsLineInclude endp

Filter proc lpWord:DWORD,lpTyped:DWORD

	mov		ecx,lpWord
	mov		edx,lpTyped
  @@:
	mov		al,[ecx]
	mov		ah,[edx]
	inc		ecx
	inc		edx
	.if ah && al
		;Not case sensitive
		.if al>='a' && al<='z'
			and		al,5Fh
		.endif
		.if ah>='a' && ah<='z'
			and		ah,5Fh
		.endif
		sub		al,ah
		je		@b
		;Not found
		xor		eax,eax
	.else
		;Found
		mov		eax,edx
	.endif
	ret

Filter endp

;This proc fills the code complete list with words from the parsed wordlist
;NOTE it is not used in this example.
;Types from api files (uppercase):
;	P=Api's from winasmApi.api
;	M=Messages from winasmMsg.api
;	C=Constants from winasmConst.api
;	S=Structures from winasmStruct.api
;	T=Types from winasmType.api
;	W=Words from winasmWord.api
;Types from parsed code files (lowercase):
;	p=Procs from project
;	l=Labels from project
;	c=Constants from project
;	d=Data (variables) from project
;	s=Structures and unions parsed from project
;	m=Macros parsed from project
;	x=Objects parsed from project (masm/ObjAsm32 only)
;	y=Methods parsed from project (masm/ObjAsm32 only)
ListFromWordlist proc uses esi,lpTypes:DWORD,lpFilter:DWORD

	invoke SendMessage,hProperty,PRM_FINDFIRST,lpTypes,lpFilter
	.while eax
		mov		esi,eax
		invoke SendMessage,hProperty,PRM_FINDGETTYPE,0,0
		;Select an image depending on the returned value
		xor		edx,edx
		.if eax=='p'
			mov		edx,1
		.elseif eax=='W'
			mov		edx,2
		.elseif eax=='c'
			mov		edx,3
		.elseif eax=='d'
			mov		edx,14
		.elseif eax=='S'
			mov		edx,4
		.elseif eax=='s'
			mov		edx,5
		.elseif eax=='m'
			mov		edx,6
		.endif
		invoke SendMessage,hCC,CCM_ADDITEM,edx,esi
		invoke SendMessage,hProperty,PRM_FINDNEXT,0,0
	.endw
	invoke SendMessage,hCC,CCM_GETCOUNT,0,0
	.if eax
		;Sort the list
		invoke SendMessage,hCC,CCM_SORT,FALSE,TRUE
		;Let RadASM show the listbox
		mov		eax,lpData
		mov		[eax].ADDINDATA.cctype,CCTYPE_USER
	.endif
	ret

ListFromWordlist endp

AddinProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	nFilter:DWORD
	LOCAL	lpFun:DWORD
LOCAL hSearch:dword
	mov		eax,uMsg
	.if eax==AIM_RASELCHANGE
		push	ebx
		push	esi
		push	edi
		mov		ebx,lParam
		.if [ebx].RASELCHANGE.seltyp==SEL_TEXT && [ebx].RASELCHANGE.fchanged
			mov		eax,lpData
			.if [eax].ADDINDATA.nAsm==nMASM
				
				.if [eax].ADDINDATA.cctype==CCTYPE_NONE || [eax].ADDINDATA.cctype==CCTYPE_USER || [eax].ADDINDATA.cctype==CCTYPE_USERTOOLTIP
					;Get the line text
					mov		esi,[ebx].RASELCHANGE.lpLine
					mov		ecx,[esi].CHARS.len
					.if ecx>=sizeof linebuff
						mov		ecx,sizeof linebuff-1
					.endif
					lea		esi,[esi+sizeof CHARS]
					mov		edi,offset linebuff
					rep movsb
					;Zero terminate line
					mov		byte ptr [edi],0
					.if byte ptr [edi-1]==VK_RETURN
						;Dont want CR
						mov		byte ptr [edi-1],0
					.endif
					mov		eax,[ebx].RASELCHANGE.chrg.cpMin
					sub		eax,[ebx].RASELCHANGE.cpLine
					push eax
					invoke IsLineInclude,addr szIsLineInclude,eax
					.if eax
						
						mov		edi,eax
						sub		eax,offset linebuff
						mov		nPos,eax
						invoke SendMessage,hCC,CCM_CLEAR,0,0
		
						mov		esi,offset FileDataInc
						.while byte ptr [esi]
							 
						       invoke Filter,esi,edi
							   .if eax
								   invoke SendMessage,hCC,CCM_ADDITEM,0,esi
							   .endif
							  
							   invoke lstrlen,esi
							   lea		esi,[esi+eax+1]
						.endw
              
						invoke SendMessage,hCC,CCM_GETCOUNT,0,0
						.if eax
							;Let RadASM show the listbox
							mov		eax,lpData
							mov		[eax].ADDINDATA.cctype,CCTYPE_USER
						.endif
					.endif
					pop eax
					
					invoke IsLineInclude,addr szIsLineIncludelib,eax
					.if eax
						
						mov		edi,eax
						sub		eax,offset linebuff
						mov		nPos,eax
						invoke SendMessage,hCC,CCM_CLEAR,0,0
		
						mov		esi,offset FileDataLib
						.while byte ptr [esi]
						       invoke Filter,esi,edi
							   .if eax
								   invoke SendMessage,hCC,CCM_ADDITEM,0,esi
							   .endif
							   invoke lstrlen,esi
							   lea		esi,[esi+eax+1]
						.endw
              
						invoke SendMessage,hCC,CCM_GETCOUNT,0,0
						.if eax
							;Let RadASM show the listbox
							mov		eax,lpData
							mov		[eax].ADDINDATA.cctype,CCTYPE_USER
						.endif
					.endif
					
				.endif
			.endif
		.endif
		pop		edi
		pop		esi
		pop		ebx
 	.endif
	xor		eax,eax
  Ex:
	ret

AddinProc Endp

ReadIncludes_Includelibs proc pWinasmApiPath:DWORD,pFileData:DWORD
	LOCAL	nBytes:DWORD
    push edi
    push esi
    invoke CreateFile,pWinasmApiPath,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
    .if eax!=INVALID_HANDLE_VALUE
	mov		edi,eax
	invoke GetFileSize,edi,NULL
	mov		edx,eax
	mov		esi,pFileData
	invoke ReadFile,edi,esi,edx,addr nBytes,NULL
	invoke CloseHandle,edi
	mov		edi,esi
	.while byte ptr [esi]
		mov		al,[esi]
		inc		esi
		.if al!=0Ah
			.if al==0Dh
				mov		al,0
				inc		esi
			.endif
			mov		[edi],al
			inc		edi
		.endif
	.endw
	mov		byte ptr [edi],0
	 .endif
	pop		edi
	pop		esi
	ret
ReadIncludes_Includelibs endp

SearchIncludes_Includelibs proc pWinasmApiPath:DWORD,pFilter :DWORD
LOCAL hSearch:dword
LOCAL	nBytes:DWORD
push edi

    invoke CreateFile, pWinasmApiPath, GENERIC_WRITE, FILE_SHARE_WRITE, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    .if eax!=INVALID_HANDLE_VALUE
	       mov		edi,eax
    
    invoke FindFirstFile,pFilter,addr w32
	mov hSearch,eax
	.if hSearch!=INVALID_HANDLE_VALUE		
		.while eax!=0			
			invoke FindNextFile,hSearch,addr w32
			push eax
			;invoke PathRemoveExtension,addr w32.cFileName
			invoke lstrlen,addr w32.cFileName
			mov ebx,eax
			
			invoke WriteFile,edi,addr w32.cFileName,ebx,addr nBytes,0
            invoke WriteFile,edi,addr szReturnLine,2,addr nBytes,NULL			
			pop eax			
		.endw
		invoke FindClose,hSearch
	.endif	
	 invoke CloseHandle, edi
	.endif		
	ret
SearchIncludes_Includelibs endp

;#########################################################################

End DllEntry
